c
c	basic grid point resolution parameters for ocean model
c
      integer uwlat, uwlon, maxoverlaps,maxcoverlaps
      integer puwlat,puwlon
      parameter(uwlat = 128, uwlon = 128,
     $	        maxoverlaps = 8, maxcoverlaps = 20,
     $	        puwlat = uwlat/p_nproc_lt,
     $		puwlon = uwlon/p_nproc_ln)

c   overlap grid to surface grid mapping common block
c   plus lat,lon index ranges
      integer ctoulon,
     $	      ctoulat,
     $        overlaps 
      integer plats,plate,plons,plone,ccmplats
      integer ccmplate,ccmplons,ccmplone
      integer uwmask  ! uw land mask
      real  reuwarea ! area of uw cell in real units
      real*8  uwarea,  ! area of uw cell divided by R**2
     $       cweight   !

      common /wghtdat/ctoulon(uwlat,uwlon,maxoverlaps),
     $		      ctoulat(uwlat,uwlon,maxoverlaps),
     $		      overlaps(uwlat,uwlon),plats(2),plate(2),
     $                plons,plone,ccmplats(2),ccmplate(2),
     $		      ccmplons,ccmplone,
     $		      uwmask(uwlon,uwlat),
     $		      reuwarea(uwlat),uwarea(uwlat),
     $		      cweight(uwlat,uwlon,maxoverlaps)

c  run control logic for the coupler
      logical resalready
      integer rsfreq,hisfreq,rnlng,finished,hiscount,rescount
      common /restartdata/resalready,rsfreq,hisfreq,rnlng,finished,
     $			hiscount,rescount
