C
C Parameters related to spectral domain
C

c
c truncation parameters specified via preprocessor
c

#ifdef PP_TRIANG_TRUNC
#   define PP_PTRM PP_TRIANG_TRUNC
#   define PP_PTRN PP_TRIANG_TRUNC
#   define PP_PTRK PP_TRIANG_TRUNC
#endif

#ifdef PP_RHOMB_TRUNC
#  define PP_PTRM PP_RHOMB_TRUNC
#   define PP_PTRN PP_RHOMB_TRUNC
#   define PP_PTRK (2 * PP_RHOMB_TRUNC)
#endif


c
c defaults for T42 and parallel implementation
c
#ifndef PP_PTRM
#    define PP_PTRM 42
#endif
#ifndef PP_PTRN
#    define PP_PTRN 42
#endif
#ifndef PP_PTRK
#    define PP_PTRK 42
#endif

      integer
     $     ptrm,   !  m truncation parameter
     $     ptrn,   !  n truncation parameter
     $     ptrk,   !  k truncation parameter
     $     pmax,
     $     pmaxp,
     $     pnmax,
     $     pmmax,
     $     par0,   ! intermediate parameter
     $     par2,   ! intermediate parameter
     $     p_gspt, ! dimension for global legendre array
     $     pspt,   ! dimension for legendre array
     $     psp,    ! dimension for legendre array
     $     pspl    ! dimension for legendre array
C
      parameter(ptrm=PP_PTRM,ptrn=PP_PTRN,ptrk=PP_PTRK)
      parameter(pmax=ptrn+1,pmaxp=pmax+1,pnmax=ptrk+1,pmmax=ptrm+1)
      parameter(par0=ptrm+ptrn-ptrk,par2=par0*(par0+1)/2)

      parameter(p_gspt=(ptrn+1)*pmmax-par2)

c including this file computes proper value for PP_PSPT
#include "p_spetab.com"

      parameter(pspt=PP_PSPT)
      parameter(psp=2*pspt)
      parameter(pspl=psp*plev)

