#include "params.h"
      subroutine blowup
C-----------------------------------------------------------------------
C
C Model is blowing up or something went wrong reading the boundary datasets.
C Dispose current history tape and quit.  This routine was cannibalized
C from WRAPUP.  It was not possible to simply include the history dispose
C logic in ENDRUN because of potential recursion problems.
C
C--------------------------Code history---------------------------------
C
C Original version  J. Rosinski, April 1993
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------Commons----------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
C
C Local variables
C
      integer ktape        ! History tape index
      logical lremov       ! Remove link after dispose?
C
C Externals
C
      external abort,      ! Stop the model
     $         savdis      ! Send history tape(s) to the mass store
C
C-----------------------------------------------------------------------
C
      lremov = .false.
      do ktape=1,mtapes
         call savdis(hunit(ktape),hpath   ,nhfil(ktape),
     $                  cpath(ktape),nswrps  ,
     $               nsmvn   ,irt     ,msscom  ,ldebug  ,lremov  ,
     $               async   )
      end do
      call abort
      return
      end
