#include "params.h"
      subroutine intbnd
C-----------------------------------------------------------------------
C
C Initialize boundary condition datasets
C
C---------------------------Code history--------------------------------
C
C Original version:  L. Bath, April 1992
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------Commons----------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C---------------------------Local variables-----------------------------
C
      integer bsiz        ! Fortran library buffer size for file assign
C
C------------------------------Externals--------------------------------
C
      external atchbnd,   ! Attach boundary datasets
     $         tiread,    ! Read time-invariant dataset
     $         sstini,    ! Read sst dataset
     $         oznini     ! Read ozone dataset
C
C Read time-independent boundary dataset
C
      bsiz = 100
      call atchbnd(nbndti  ,bndti   ,bsiz    ,'U'     )
      call tiread (nbndti  )
C
C Read time-dependent sst boundary dataset
C
#ifndef COUPLED
      bsiz = 100
      call atchbnd(nsst    ,bndtvs  ,bsiz    ,'U'     )
      call sstini (nsst    )
#endif
C
C Read time-dependent ozone boundary dataset
C
      bsiz = 100
      call atchbnd(nozone  ,bndtvo  ,bsiz    ,'U'     )
      call oznini (nozone  )
C
      return
      end
