#include "params.h"
      subroutine rgnfls
C-----------------------------------------------------------------------
C
C Assign and preallocate space for the regeneration files.
C
C-----------------------------------------------------------------------
      implicit none
C-----------------------------------------------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C---------------------------------------------------------------------
#include "commss.com"
C---------------------------local workspace----------------------------
      character iuch*2             ! unit number (coded)
      character itmp*2             ! temporary for unit number
      character cbsiz*4            ! buffer size (coded)
      character text*130           ! string sent to assign
      integer 
     $     nf                   ! file number
      character
     $     fname*8,             ! file name
     $     ctemp*8,             ! temp to format size for assign call
     $     csiz*8               ! final block size for preallocation
C----------------------------externals---------------------------------
      integer
     $     lenchr
      external 
     $     assign,
     $     lenchr,
     $     ljust
C----------------------------------------------------------------------
#ifndef PP_PCCM
C
C Assign the master regeneration file but do not preallocate space for it
C
      write(itmp,'(i2)') nrg
      call ljust(itmp,iuch)
      text = 'assign -a '//nrfil(1:lenchr(nrfil))//
     $     ' fort.'//iuch
      write(6,800) text
      call assign(text)
C
C Assign the primary regeneration files.
C
      write(cbsiz,'(i4)') rg1buf
      do nf = 1, nnrg1
         fname = nrfil(1:lenchr(nrfil)) // rg1ext(nf)
         write(itmp,'(i2)') nrg1(nf)
         call ljust(itmp,iuch)
         write(ctemp,'(i8)') rg1siz(nf)
         call ljust(ctemp,csiz)
         text = 'assign -a '//fname//
     $        ' -b '//cbsiz(1:lenchr(cbsiz))//
     $        ' -n '//csiz(1:lenchr(csiz))//' fort.'//iuch
         write(6,800) text
         call assign(text)
      end do
C
C Assign the secondary regeneration files.
C
      if (aeres) then
         write(cbsiz,'(i4)') rg2buf
         do nf = 1, nnrg2
            fname = nrfil(1:lenchr(nrfil)) // rg2ext(nf)
            write(itmp,'(i2)') nrg2(nf)
            call ljust(itmp,iuch)
            write(ctemp,'(i8)') rg2siz(nf)
            call ljust(ctemp,csiz)
            text = 'assign -a '//fname //
     $           ' -b '//cbsiz(1:lenchr(cbsiz))//
     $           ' -n '//csiz(1:lenchr(csiz))//' fort.'//iuch
            write(6,800) text
            call assign(text)
         end do
      endif
  800 format('RGNFLS: sending the following to assign:',a)
#endif
      return
      end
