c $Header: /homes/jacob/foam-cvs/pcoupler/coup_restrt.F,v 1.6 2002/09/22 16:23:24 jacob Exp $
#include "params.h"
#undef REMOVEOLDICE
#undef REMOVEOLDSNOW

      subroutine coup_restrt(time_inv,tilen)

      implicit none

c------------------------------------------------
#include "pmgrid.com"
c------------------------------------------------
#include "pagrid.com"
c------------------------------------------------
#include "pspect.com"
c------------------------------------------------
#include "comparll.com"
c------------------------------------------------
#include "comcon.com"
c------------------------------------------------
#include "pcoupled.com"
c------------------------------------------------
#include "pradalb.com"
c------------------------------------------------
#include "pccm2lnd.com"
c------------------------------------------------
#include "povrlp2a.com"
c------------------------------------------------
#include "priver.com"
c------------------------------------------------
#include "pcplrstr.com"
c------------------------------------------------
#include "pccmcoup.com"
c------------------------------------------------
#ifdef FOAM_LPJ
#include "plpj.com"
#endif
c------------------------------------------------
      real afsul(p_glon,p_glat)
      real albs(p_glon,p_glat)
      real albl(p_glon,p_glat)
      real albsd(p_glon,p_glat)
      real albld(p_glon,p_glat)
      real blah,ts2,sst2
      integer ccmrow,ic,jc,kc,i,j,k,row
#ifdef FOAM_LPJ
      integer pft
#endif
      integer i2,j2,n
      integer ilon,ilat,ilev
      character*256 time_inv
      integer tilen
      character*256 datafile
      character itf*8
      character resname*256
#ifdef FOAM_LPJ
      character lpjresname*256
#endif
      integer stfnum

      hiscount = 1
      rescount = 1

      
      datafile = time_inv(1:tilen) // '/' //
     $ 'mask.128x128'
      open(21,file=datafile,
     $status='old')
      do j=1,uwlat
      do i=1,uwlon
	read(21,*) ilon,ilat,uwmask(i,j)
      enddo
      enddo
      close(21)

#if(PP_TRIANG_TRUNC==21)
      datafile = time_inv(1:tilen) // '/' //
     $  'oro.ascii'
      open(22,file=datafile,
     $status='old')
#endif
#if(PP_RHOMB_TRUNC==15)
      datafile = time_inv(1:tilen) // '/' //
     $  'mask.r15'
      open(22,file=datafile,
     $status='old')
#endif
      do j=1,p_glat
       do i=1,p_glon
        read(22,*) ilon,ilev,ilat,ccm2mask(i,j)
       enddo
      enddo
      close(22)

      datafile = time_inv(1:tilen) // '/' //
     $  'area.128'
      open(23,file=datafile,status='old')
         do i=1,uwlat
           read(23,*) uwarea(i)

c set the real surface area used by river model
           reuwarea(i)=uwarea(i)*4.0678e13
         enddo
      close(23)

#if(PP_TRIANG_TRUNC==21)
      datafile = time_inv(1:tilen) // '/' //
     $  't21area'
      open(24,file=datafile,status='old')
#endif
#if(PP_RHOMB_TRUNC==15)
      datafile = time_inv(1:tilen) // '/' //
     $  'r15area'
      open(24,file=datafile,status='old')
#endif
         do i=1,p_glat
           read(24,*) ccm2area(i)
         enddo
      close(24)

#if(PP_TRIANG_TRUNC==21)
      datafile = time_inv(1:tilen) // '/' //
     $  'weights.128x128_t21'
      open(25,file=datafile,
     $status='old')
#endif
#if(PP_RHOMB_TRUNC==15)
      datafile = time_inv(1:tilen) // '/' //
     $  'weights.128x128_r15'
      open(25,file=datafile,
     $status='old')
#endif
      do i = 1,uwlat
      do j =1, uwlon
          read(25,*) i2,j2,overlaps(i2,j2)
          if( (i2 .ne. i) .or. (j2 .ne. j) ) then
            write(6,*) 'error on input'
          endif
           do k=1,overlaps(i2,j2)
            read(25,*) ctoulat(i2,j2,k),ctoulon(i2,j2,k),
     $      cweight(i2,j2,k)
c           write(6,*) ctoulat(i2,j2,k),ctoulon(i2,j2,k),
c    $      cweight(i2,j2,k)
          enddo
      enddo
      enddo
      close(25)

#if(PP_TRIANG_TRUNC==21)
      datafile = time_inv(1:tilen) // '/' //
     $  'weights.t21_128x128'
      open(26,file=datafile,
     $status='old')
#endif
#if(PP_RHOMB_TRUNC==15)
      datafile = time_inv(1:tilen) // '/' //
     $  'weights.r15_128x128'
      open(26,file=datafile,
     $status='old')
#endif
      do i = 1,p_glat
      do j =1, p_glon
          read(26,*) i2,j2,coverlaps(i2,j2),blah
          if( (i2 .ne. i) .or. (j2 .ne. j) ) then
            write(6,*) 'error on input'
          endif
           do k=1,coverlaps(i2,j2)
            read(26,*) utoclat(i2,j2,k),utoclon(i2,j2,k),
     $          utocwch(i2,j2,k)
          enddo
      enddo
      enddo
      close(26)

      datafile = time_inv(1:tilen) // '/' //
     $  'vegtyp.128x128'
      open(43,file=datafile,status='old')
      datafile = time_inv(1:tilen) // '/' //
     $  'rghnss.128x128'
      open(44,file=datafile,status='old')
      datafile = time_inv(1:tilen) // '/' //
     $  'frctst.128x128'
      open(46,file=datafile,status='old')
      datafile = time_inv(1:tilen) // '/' //
     $  'albnis.128x128'
      open(47,file=datafile,status='old')
      datafile = time_inv(1:tilen) // '/' //
     $  'albniw.128x128'
      open(48,file=datafile,status='old')
      datafile = time_inv(1:tilen) // '/' //
     $  'albvss.128x128'
      open(49,file=datafile,status='old')
      datafile = time_inv(1:tilen) // '/' //
     $  'albvsw.128x128'
      open(50,file=datafile,status='old')
#ifdef RIVER
      datafile = time_inv(1:tilen) // '/' //
     $  'rdirc.128x128'
      open(40,file=datafile,status='old')
      datafile = time_inv(1:tilen) // '/' //
     $  'effvel.128x128'
      open(41,file=datafile,status='old')
      datafile = time_inv(1:tilen) // '/' //
     $  'ddist.128x128'
      open(42,file=datafile,status='old')
#endif
      do j=1,uwlat
      do i=1,uwlon
          read(43,*) i2,j2,ovegtyp(i,j)
          read(44,*) i2,j2,orghnss(i,j)
          read(46,*) i2,j2,ofrctst(i,j)
          read(47,*) i2,j2,oalbnis(i,j)
          read(48,*) i2,j2,oalbniw(i,j)
          read(49,*) i2,j2,oalbvss(i,j)
          read(50,*) i2,j2,oalbvsw(i,j)

#ifdef RIVER
          read(40,*) i2,j2,rdirc(i,j)
          read(41,*) i2,j2,effvel(i,j)
          read(42,*) i2,j2,ddist(i,j)
#endif
      enddo
      enddo
      close(43)
      close(44)
      close(46)
      close(47)
      close(48)
      close(49)
      close(50)
#ifdef RIVER
      close(40)
      close(41)
      close(42)
#endif

      do i=1,p_glon
      do j=1,p_glat
        aoro(i,j) = ccm2mask(i,j)
      enddo
      enddo

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       READ RESTART DATA
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      stfnum = finished
      write(itf,'(i8)') stfnum + 10000000
      resname = 'restart/coupl/restart.coupl.'//itf(2:8)

      open(90,file=resname,
     $form='unformatted',status='old')

#ifdef READ1_0
      read(90) tssub,sndpth,thickn,ws,oro,ioro,volr,fluxout,
     $sfluxin,lwuphf,afsul,albs,albl,albsd,albld,sst,delts,
     $oioro
#endif
#ifdef READ1_4
      read(90) tssub,sndpth,thickn,ws,oro,ioro,volr,fluxout,
     $sfluxin,lwuphf,afsul,albs,albl,albsd,albld,sst,delts,
     $oioro,oqflx
#endif
#ifdef READ1_5
      read(90) tssub,sndpth,thickn,ws,oro,ioro,volr,fluxout,
     $sfluxin,lwuphf,afsul,albs,albl,albsd,albld,sst,delts,
     $oioro,meltp,fice,tsnow,qstor,lwuphfi,lwuphfo
#endif
      close(90)

#ifdef FOAM_LPJ
c
c  Read in lpj restart data
c
      lpjresname = 'restart/coupl/restart.colpj.'//itf(2:8)

      open(57,file=lpjresname,form='unformatted',
     $ status='old')

      read(57) aet,aeq,suph,gp,dphen,fpcgrid,aetd,aeqd,gdd,
     $ aphen,litter_ag,litter_bg,height,lm_ind,sm_ind,rm_ind,hm_ind,
     $ anpp,nind,mgpp,lrespm,srespm,rrespm,gddtw,awscal,
     $ aleafdays,ipresent,ifrost,fbare,wu,wl,laettot,k_fast_ave,
     $ k_slow_ave,litter_decom_ave,cpool_fast,cpool_slow,aprec,gddclim,
     $ tsm,wum,tsm_min20
      close(57)

c
c  set frost and present logicals
c
      do i=1,uwlon
      do j=1,uwlat
      do pft=1,npft
       frost(i,j,pft)=.false.
       present(i,j,pft)=.false.
       if(ifrost(i,j,pft).eq.1) frost(i,j,pft)=.true.
       if(ipresent(i,j,pft).eq.1) present(i,j,pft)=.true.
      enddo
       enddo
        enddo

#endif


c figure out what the start and end indicies are
c of the longitude section of the surface handled by this processor
      row = (uwlat/p_nproc_lt)/2
      plons = 1 + m_pin_ln*(uwlon/p_nproc_ln)
      plone = (m_pin_ln + 1)*(uwlon/p_nproc_ln)

c figure out what the start and end indicies are
c of the southern hemisphere latitude section of the surface 
c  handled by this processor
      plats(1) = 1 + m_pin_lt*row
      plate(1) = plats(1) + (row - 1)

c northern hemisphere section
      plats(2) = uwlat - (m_pin_lt+1)*row + 1
      plate(2) = plats(2) + row - 1

c figure out what the start and end indicies are
c of the longitude section of the atmosphere handled by this 
c processor
      ccmrow = (p_glat/p_nproc_lt)/2
      ccmplons = 1 + m_pin_ln*(p_glon/p_nproc_ln)
      ccmplone = (m_pin_ln + 1)*(p_glon/p_nproc_ln)

c figure out what the start and end indicies are
c of the southern hemisphere latitude section of the atmosphere
c  handled by this processor
      ccmplats(1) = 1 + m_pin_lt*ccmrow
      ccmplate(1) = ccmplats(1) + (ccmrow - 1)

c northern hemisphere section
      ccmplats(2) = p_glat - (m_pin_lt+1)*ccmrow + 1
      ccmplate(2) = ccmplats(2) + ccmrow - 1

      do n=1,2
       do j=plats(n),plate(n)
         do i=plons,plone
#ifndef READ1_5

c  if not using CSIMICE, new field fice should be 1.0
c  wherever there is ice.
# ifndef CSIMICE
         if(ioro(i,j) .eq. 2) fice(i,j)=1.
# endif

c make sure fice is defined as 0. over land.
         if(uwmask(i,j) .eq. 1) fice(i,j)=0.

         ts2=tssub(i,j,1)*tssub(i,j,1)
	 sst2=sst(i,j)*sst(i,j)
	 lwuphfi(i,j)=stebol*ts2*ts2
	 lwuphfo(i,j)=stebol*sst2*sst2

         tice(i,j,1)=0.
         tice(i,j,2)=0.
         tsnow(i,j)=0.
         tinter(i,j)=0.
         qstor(i,j)=0.
c if running CSIMICE and not using a 1.5 restart
c initialize with no sea ice
# ifdef CSIMICE
         if(uwmask(i,j).eq.0) then
          sndpth(i,j)=0.
          ioro(i,j)=0
          oro(i,j)=0.
	  fice(i,j)=0.
	  thickn(i,j)=0.
	  tssub(i,j,1)=sst(i,j)
	  tssub(i,j,2)=sst(i,j)
	  tssub(i,j,3)=sst(i,j)
	  tssub(i,j,4)=sst(i,j)
         endif
# endif
#else
# ifdef CSIMICE
         if(ioro(i,j) .eq. 2) then
           tinter(i,j)=tssub(i,j,2)
	   tice(i,j,1)=tssub(i,j,3)
	   tice(i,j,2)=tssub(i,j,4)
	 else
	   tinter(i,j)=0.
	   tice(i,j,1)=0.
	   tice(i,j,2)=0.
	 endif
# else
	 tinter(i,j)=0.
	 tice(i,j,1)=0.
	 tice(i,j,2)=0.
# endif
#endif
         enddo
       enddo
      enddo   


c set longwave and albedos up
      jc =1
      do kc=1,2
      do j=ccmplats(kc),ccmplate(kc)
	 ic=1
	 do i=ccmplons,ccmplone
	  from_coupler(ic,jc,14)=afsul(i,j)
	  from_coupler(ic,jc,15)=albs(i,j)
	  from_coupler(ic,jc,16)=albl(i,j)
	  from_coupler(ic,jc,17)=albsd(i,j)
	  from_coupler(ic,jc,18)=albld(i,j)
          ic=ic+1
         enddo
       jc=jc+1
      enddo
      enddo

      return
      end
