C
C Gravity wave drag constants
C
      common/comgw/cappa   ,gravit  ,vmin    ,v0      ,hmin    ,
     $             fc2     ,fudge   ,tnlim   ,bv2min  ,g2or    ,
     $             g2ocp   ,fgor    ,cpair   ,cpvir
C
      real cappa,    ! R/cp
     $     gravit,   ! Acceleration of gravity
     $     vmin,     ! Threshold value lowest lev wind for gwd to apply
     $     v0,       ! Approximately zero wind
     $     hmin,     ! Threshold value of orographic standard deviation
     $     fc2,      ! Critical froude number squared
     $     fudge,    ! Tunable parameter e*mu/2 = e*pi/l
     $     tnlim,    ! Max |v| tendency, 250 m/s/day
     $     bv2min,   ! Min value of Brundt-Vaisala frequency squared
     $     g2or,     ! -(gravit**2)/rair
     $     g2ocp,    !  (gravit**2)/cpair
     $     fgor,     ! Fudge*gravit/rair
     $     cpair,    ! Specific heat of dry air
     $     cpvir     ! Derived constant for cp of moist air
C
