C
C ozone mixing ratios, pressures and times
C
      integer pnoz,     ! Maximum number of levels in ozone input data
     $        pnozp1,   ! pnoz+1
     $        pozlon    ! Number of ozone longitudes
      parameter (pnoz=100)
      parameter (pnozp1=pnoz+1)
      parameter (pozlon=1)
C
      common /comozp/ldoyoz  ,ndoyoz  ,cplos   ,cplol   ,
     $               ozmix(plat,pnoz),ozmixm(pozlon,pnoz,plat,2),
     $               pin(pnozp1),plol0(plat,pnozp1),plos0(plat,pnozp1),
     $               koz,nyroz
C
      real ldoyoz,   ! Day of yr of ozone data prior to current date
     $     ndoyoz,   ! Day of yr of ozone data after current date
     $     cplos,    ! Constant for ozone path length calculation
     $     cplol,    ! Constant for pressure-weighted o3 path lngth calculation
     $     ozmix,    ! Time-interpolated mixing ratios
     $     ozmixm,   ! Two consecutive time slices of ozone mixing ratios
     $     pin,      ! Pressures at model interfaces
     $     plol0,    ! Pressure weighted ozone path length (cm)
     $     plos0     ! Ozone path length (cm)
      integer
     $     koz,      ! Number of levels in ozone input data
     $     nyroz     ! Year of ozone data just after current date
C
