C
C Global integrals for moisture and mass conservation
C
#ifdef PP_PCCM
c doubled size of tq, dq, and tmass for reproducibility in 
c mint(), scan1(), and scan2()
      common/comqfl/tq(plat,plev),dq(plat,plev),tmass(plat),
     $              tqf(plev)      ,dqf(plev)      ,qflrat(plev),
     $              tmass0         ,tmassf         ,qmassf,
     $              fixmas         ,qmass1         ,qmass2,
     $              pdela(plond,plev)
#else
      common/comqfl/tq(plat/2,plev),dq(plat/2,plev),tmass(plat/2),
     $              tqf(plev)      ,dqf(plev)      ,qflrat(plev),
     $              tmass0         ,tmassf         ,qmassf,
     $              fixmas         ,qmass1         ,qmass2,
     $              pdela(plond,plev)
#endif
C
      real tq,      ! moisture integral for each latitude pair, level
     $     dq,      ! integral of neg moisture for each lat pair,level
     $     tmass,   ! mass integral for each latitude pair
     $     tqf,     ! global moisture integral for each level
     $     dqf,     ! global integral of neg moisture for each level
     $     qflrat,  ! proportionality factor for global negative 
C                   !  moisture fixer
     $     tmass0,  ! specified dry mass of atmosphere
     $     tmassf,  ! global mass integral
     $     qmassf,  ! global moisture integral
     $     fixmas,  ! proportionality factor for ps in dry mass fixer
     $     qmass1,  ! Contribution to global moisture integral (mass
C                   !  weighting is based upon the "A" part of the 
C                   !  hybrid grid)
     $     qmass2,  ! Contribution to global moisture integral (mass
C                   !  weighting is based upon the "B" part of the 
C                   !  hybrid grid)
     $     pdela    ! pressure difference between interfaces (pressure
C                   !  defined using the "A" part of hybrid grid only)
