      integer
     $     nstart, ! Starting indices for spectral arrays (real)
     $     nlen
c
      real vz,       ! Vorticity spectral coefficients
     $     d,        ! Divergence spectral coefficients
     $     t,        ! Temperature spectral coefficients
     $     q,        ! Moisture spectral coefficients
     $     alps,     ! Log-pressure spectral coefficients
     $     alp,      ! Legendre polynomials
     $     dalp      ! Legendre polynomial derivatives
#ifdef PP_PCCM
      integer stack_ptr, stack_size

#ifdef PP_RHOMB_TRUNC
      parameter ( stack_size = max((p_log2plat), 1 ))
#else 
      parameter ( stack_size = max((p_log2plat - 1), 1 ))
#endif

      common/comspe/vz(pspl*stack_size),
     $              d(pspl*stack_size),
     $              t(pspl*stack_size),
     $              q(pspl*stack_size),
     $              alps(psp*stack_size),
     $              alp(pspt,plat/2),dalp(pspt,plat/2),
     $              stack_ptr,
     $              nstart(pmmax),nlen(pmmax)
#else
      common/comspe/vz(pspl),d(pspl),t(pspl),q(pspl),alps(psp),
     $              alp(pspt,plat/2),dalp(pspt,plat/2),
     $              nstart(pmmax),nlen(pmmax)
#endif
