       integer rstrt_sz_hdr, rstrt_sz_nrx, rstrt_sz_ems, rstrt_sz_slt
       parameter (rstrt_sz_hdr=
     $   4                                 ! section, length, lat, and lon
     $           )

       parameter (rstrt_sz_nrx=
     $   (pbflnb+pbflna)/plond+pbflna/plond +    ! nrb and nra
     $   2 * plev * (3+pcnst) +            ! 3d variables at two time levels
     $   3 * plev +                        ! lammp, phimp, and sigmp
     $   2 * plev * pcnst +                ! moisture (hqfcst and qfcst)
     $   2                                 ! surf. pres at two time levels
     $           )

       parameter (rstrt_sz_ems=
     $   plev * 4 +                        ! absnxt  (abs/ems)
     $   plevp * plevp +                   ! abstot  (abs/ems)
     $   plevp                             ! emstot  (abs/ems)
     $           )

       parameter (rstrt_sz_slt=
     $   pcnst +                           ! hw1     (slt)
     $   pcnst +                           ! hw2     (slt)
     $   pcnst +                           ! hw3     (slt)
     $   pcnst                             ! alpha   (slt)
     $           )

       integer rstrt_words
#ifdef PP_NORESTART
       parameter (rstrt_words= 1 )
#else
       parameter (rstrt_words=
     $   3*rstrt_sz_hdr +
     $   rstrt_sz_nrx +
     $   rstrt_sz_ems +
     $   rstrt_sz_slt
     $           )
#endif

       real rstrt_buf( rstrt_words * plon * plat )	! output buffer

       common /rstrt_buf_com/ rstrt_buf

