#include "params.h"
      integer function navu()
C-----------------------------------------------------------------------
C
C Utility function to return index of next available Fortran
C unit number.
C
C---------------------------Code history--------------------------------
C
C Original version:  J. Rosinski
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Commons----------------------------------
#include "pmgrid.com"
#include "pagrid.com"
#include "comlun.com"
#include "pspect.com" 
#include "comparll.com"
C---------------------------Local variables-----------------------------
C
      integer itst      ! Index
C
C------------------------------Externals--------------------------------
C
      external endrun   ! Abnormal termination
C
C-----------------------------------------------------------------------
C
      do itst=1,99
         if(.not.lutag(itst)) then
            navu = itst
            lutag(itst) = .true.
            return
         end if
      end do
      write(0,*) 'NAVU: Ran out of Fortran unit numbers'
      call endrun
      end
