#include "params.h"
      subroutine writeric(kdv,pa,klen,krec)
c--------------------------------------------------------------------
c   8/92
c
c   Modified for intel specific I/O on gamma and delta.
c     This is compiled in if INTEL is defined for the preprocessor
c     If INTEL is not specified, normal (original) I/O is enabled
c     unless incore storage is specified.
c
c   Modified for incore storage.  
c     Data is "written"
c     to memory (see incore.com).
c     Some routines, notably radclw(), physdrv() (new), and xformdrv() (new)
c     equivalence this same storage and use it directly, bypassing these
c     routines.  Others, such as inidat() and spegrd(), still use these
c     routines.
c     
c--------------------------------------------------------------------
c inserted by implnone
      implicit none
c declarations inserted by implnone
      integer kdv,klen,krec

#   include "pmgrid.com"
#   include "pagrid.com"
#   include "pspect.com"
#   include "comparll.com"
#   include "comlun.com"
#   include "abemub.com"
#   include "incore.com"
      integer offset, i

      real pa(klen)
      if      ( kdv .eq. nra1  ) then           ! unit a
          offset = incore_a   + (krec-1)*pflena
      else if ( kdv .eq. nrb1  ) then           ! unit b
          offset = incore_b   + (krec-1)*pflenb
      else if ( kdv .eq. nabem ) then           ! unit ems
          offset = incore_ems + (krec-1)*plngbuf
      else
#ifdef PP_ERROR
          write(0,*)'incore error on unit ',kdv
#endif
          call abortf('writeric')
      endif

      do i = 1, klen
          y( offset ) = pa(i)
          offset = offset + 1
      enddo
      return
  900 write(6,*)'unit ',kdv,'bad write of record ',krec
      call endrun
      end
